import { readdirSync } from 'fs';
import { join } from 'path';

// utils must build before core
const headPkgs = [
  // 'DeviceTree',
  // 'Empty',
  // 'HistoryInfo',
  // 'ImageSelect',
  // 'MqttView',
  // 'QuotaSelect',
  // 'RealTimeInfo',
  // 'TimeRangePicker',
];
const pkgList = ['base-components', 'extend-components']
  .map((dir) => {
    const list = readdirSync(join(__dirname, 'packages', dir)).map((item) => `${item}!${dir}`);
    return list;
  })
  .flat();

const tailPkgs = pkgList
  .filter((pkg) => pkg.charAt(0) !== '.' && !headPkgs.includes(pkg))
  .map((item) => {
    const [name, path] = item.split('!');
    return `${path}/${name}`;
  });

export default {
  cjs: { type: 'babel', lazy: true },
  esm: {
    type: 'babel',
    importLibToEs: true,
  },
  pkgs: [...headPkgs, ...tailPkgs],
  extraBabelPlugins: [
    ['babel-plugin-import', { libraryName: 'antd', libraryDirectory: 'es', style: true }, 'antd'],
    [require('./scripts/replaceLib')],
  ],
};
